//Summery code

/*
  De code is niet extreem moeilijk maar krijg het voor elkaar. Het assigned eerst de pins van de relay en houd 8 pins over voor de rijen en kolommen.
  Ook worden er in het begin libraries ingeladen voor de keypad en het aansturen van de LCD.
  
*/

#include <Keypad.h>                 //Library voor de keypad
#include <LiquidCrystal_I2C.h>      //Library voor de LCD
const int RELAY_PIN  = A0;          // the Arduino pin, which connects to the IN pin of relay
const int ROW_NUM    = 4;           //four rows
const int COLUMN_NUM = 4;           //four columns

//assign the rows and collums
char keys[ROW_NUM][COLUMN_NUM] = {
  {'1','2','3', 'A'},
  {'4','5','6', 'B'},
  {'7','8','9', 'C'},
  {'*','0','#', 'D'}
};

//connect the rows and collums to the acording pins
byte pin_rows[ROW_NUM] = {9, 8, 7, 6}; //connect to the row pinouts of the keypad
byte pin_column[COLUMN_NUM] = {5, 4, 3, 2}; //connect to the column pinouts of the keypad

Keypad keypad = Keypad( makeKeymap(keys), pin_rows, pin_column, ROW_NUM, COLUMN_NUM );//map the pins with the keypad rows and collums
LiquidCrystal_I2C lcd(0x27, 16, 2); // I2C address 0x27, 16 column and 2 rows

//different strings could be used for different passwords
const String password_1 = "1234ABC"; // change your password here
const String password_2 = "5642CD";  // change your password here
const String password_3 = "3548";   // change your password here
String input_password;

void setup(){
  Serial.begin(9600);
  input_password.reserve(32);    // maximum input characters is 33, change if needed
  pinMode(RELAY_PIN, OUTPUT);    // initialize pin as an output.
  digitalWrite(RELAY_PIN, HIGH); // lock the door
  lcd.init();                    // initialize the lcd
  lcd.backlight();
}

void loop(){
  char key = keypad.getKey();

  if (key){
    Serial.println(key);

    if(key == '*') {
      input_password = ""; // reset the input password
      lcd.clear();
    } else if(key == '#') {
      lcd.clear();
      if(input_password == password_1 || input_password == password_2 || input_password == password_3) {
        Serial.println("password is correct");
        lcd.setCursor(0, 0);
        lcd.print("CORRECT!");
        lcd.setCursor(0, 1);
        lcd.print("DOOR UNLOCKED!");

        digitalWrite(RELAY_PIN, LOW);  // unlock the door for 20 seconds
        delay(20000);
        digitalWrite(RELAY_PIN, HIGH); // lock the door
      } else {
        Serial.println("password is incorrect, try again");
        lcd.setCursor(0, 0);
        lcd.print("INCORRECT!");
        lcd.setCursor(0, 1);
        lcd.print("ACCESS DENIED!");
      }

      input_password = ""; // reset the input password
    } else {
      if(input_password.length() == 0) {
        lcd.clear();
      }

      input_password += key; // append new character to input password string
      lcd.setCursor(input_password.length(), 0); // move cursor to new position
      lcd.print('*');                 // print * key as hiden character
    }
  }
}
